<?php

namespace NoccyLabs\TinyEvent;

class Event
{
    protected $_type = null;

    protected $_data = [];

    protected $_stopped = false;

    public function __construct($type=null, array $data=[])
    {
        $this->_type = $type;
        $this->_data = $data;
    }

    public function setType($type)
    {
        $this->_type = $type;
    }

    public function getType()
    {
        return $this->_type;
    }

    public function stopPropagation()
    {
        $this->_stopped = true;
    }

    public function isPropagationStopped()
    {
        return $this->_stopped;
    }
    
    public function __get($key)
    {
        if (array_key_exists($key, $this->_data)) {
            return $this->_data[$key];
        }
        return null;
    }
    
    public function __isset($key)
    {
        return array_key_exists($key, $this->_data);
    }

    public function __set($key, $value)
    {
        $this->_data[$key] = $value;
    }
    
    public function __unset($key)
    {
        unset($this->data[$key]);
    }
}
