<?php

namespace NoccyLabs\TinyEvent;

trait EventEmitterTrait
{
    private $dispatcher;

    public function addListener($type, callable $handler, ...$userdata)
    {
        if (!$this->dispatcher)
            $this->dispatcher = new EventDispatcher();

        $this->dispatcher->addListener($type, $handler, ...$userdata);
    }

    protected function emitEvent($type, Event $event=null)
    {
        if (!$this->dispatcher)
            return;

        $this->dispatcher->dispatchEvent($type, $event);
    }
}
